diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java b/src/main/java/net/minecraft/client/render/item/model/BowItemModel.java
similarity index 62%
rename from src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
rename to src/main/java/net/minecraft/client/render/item/model/BowItemModel.java
index 96c130303..3ba604844 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
+++ b/src/main/java/net/minecraft/client/render/item/model/BowItemModel.java
@@ -1,21 +1,18 @@
 package net.minecraft.client.render.item.model;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.player.EntityOtherPlayerMP;
+import net.minecraft.client.entity.player.RemotePlayer;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.ItemRenderer;
 import net.minecraft.client.render.RenderEngine;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.monster.EntitySkeleton;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.entity.projectile.EntityArrow;
-import net.minecraft.core.entity.projectile.EntityArrowGolden;
-import net.minecraft.core.entity.projectile.EntityArrowPurple;
+import net.minecraft.core.entity.monster.SkeletonMob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.server.entity.player.EntityPlayerMP;
+import net.minecraft.core.item.Items;
 import org.lwjgl.opengl.GL11;
 
 import static org.lwjgl.opengl.GL11.GL_BLEND;
@@ -25,8 +22,8 @@ import static org.lwjgl.opengl.GL11.glBlendFunc;
 import static org.lwjgl.opengl.GL11.glDisable;
 import static org.lwjgl.opengl.GL11.glEnable;
 
-public class ItemModelBow extends ItemModelStandard {
-    public ItemModelBow(Item item, String namespace) {
+public class BowItemModel extends StandardItemModel {
+    public BowItemModel(Item item, String namespace) {
         super(item, namespace);
     }
 
@@ -34,13 +31,13 @@ public class ItemModelBow extends ItemModelStandard {
     public void renderItem(Tessellator tessellator, ItemRenderer renderer, ItemStack itemstack, Entity entity, float brightness, boolean handheldTransform) {
         super.renderItem(tessellator, renderer, itemstack, entity, brightness, handheldTransform);
         Item nextArrow = null;
-        if (entity instanceof EntityPlayer){
-            EntityPlayer entityplayer = (EntityPlayer)entity;
+        if (entity instanceof Player){
+            Player entityplayer = (Player)entity;
             nextArrow = getNextArrow(entityplayer);
         }
-        if (entity instanceof EntitySkeleton){
-            if (((EntitySkeleton) entity).attackTime < 5){
-                nextArrow = Item.ammoArrow;
+        if (entity instanceof SkeletonMob){
+            if (((SkeletonMob) entity).attackTime < 5){
+                nextArrow = Items.AMMO_ARROW;
             }
         }
         if (nextArrow != null){
@@ -57,30 +54,28 @@ public class ItemModelBow extends ItemModelStandard {
             glEnable(GL_BLEND);
             glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
             glEnable(GL_CULL_FACE);
-            ItemModelStandard arrowModel = (ItemModelStandard) ItemModelDispatcher.getInstance().getDispatch(nextArrow);
+            StandardItemModel arrowModel = (StandardItemModel) ItemModelDispatcher.getInstance().getDispatch(nextArrow);
             IconCoordinate textureIndex = arrowModel.getIcon(mc.thePlayer, nextArrow.getDefaultStack());
-            if (textureIndex != null) {
-                GL11.glDisable(GL_LIGHTING);
-                textureIndex.parentAtlas.bindTexture();
-                if (useColor) {
-                    final int color = getColor(itemStack);
-                    final float r = (color >> 16 & 0xff) / 255F;
-                    final float g = (color >> 8 & 0xff) / 255F;
-                    final float b = (color & 0xff) / 255F;
-                    GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
-                } else {
-                    GL11.glColor4f(brightness, brightness, brightness, alpha);
-                }
-                renderTexturedQuad(tessellator, x, y, textureIndex, true, false);
-                glEnable(GL_LIGHTING);
+            GL11.glDisable(GL_LIGHTING);
+            textureIndex.parentAtlas.bind();
+            if (useColor) {
+                final int color = getColor(itemStack);
+                final float r = (color >> 16 & 0xff) / 255F;
+                final float g = (color >> 8 & 0xff) / 255F;
+                final float b = (color & 0xff) / 255F;
+                GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
+            } else {
+                GL11.glColor4f(brightness, brightness, brightness, alpha);
             }
+            renderTexturedQuad(tessellator, x, y, textureIndex, true, false);
+            glEnable(GL_LIGHTING);
             glEnable(GL_CULL_FACE);
             glDisable(GL11.GL_BLEND);
         }
         super.renderItemIntoGui(tessellator, fontrenderer, renderengine, itemStack, x, y, brightness, alpha);
     }
-    public Item getNextArrow(EntityPlayer player){
-        if (player instanceof EntityOtherPlayerMP){
+    public Item getNextArrow(Player player){
+        if (player instanceof RemotePlayer){
             int id = player.getArrowId();
             if (id < 0 || id >= Item.itemsList.length) return null;
             return Item.itemsList[id];
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelCoal.java b/src/main/java/net/minecraft/client/render/item/model/CoalItemModel.java
similarity index 71%
rename from src/main/java/net/minecraft/client/render/item/model/ItemModelCoal.java
rename to src/main/java/net/minecraft/client/render/item/model/CoalItemModel.java
index 3d454edaa..63e5fe4a5 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelCoal.java
+++ b/src/main/java/net/minecraft/client/render/item/model/CoalItemModel.java
@@ -1,16 +1,16 @@
 package net.minecraft.client.render.item.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemModelCoal extends ItemModelStandard{
+public class CoalItemModel extends StandardItemModel {
     protected IconCoordinate charcoal = TextureRegistry.getTexture("minecraft:item/charcoal");
-    public ItemModelCoal(Item item, String namespace) {
+    public CoalItemModel(Item item, String namespace) {
         super(item, namespace);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/item/model/DoorPaintedItemModel.java b/src/main/java/net/minecraft/client/render/item/model/DoorPaintedItemModel.java
new file mode 100644
index 000000000..8cb52f0af
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/item/model/DoorPaintedItemModel.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.render.item.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+
+public class DoorPaintedItemModel extends StandardItemModel {
+    public static IconCoordinate[] doorIcons = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+    static {
+        for (DyeColor c : DyeColor.itemOrderedColors()){
+            doorIcons[c.itemMeta] = TextureRegistry.getTexture("minecraft:item/door_" + c.colorID);
+        }
+    }
+    public DoorPaintedItemModel(Item item) {
+        super(item, null);
+    }
+    public @NotNull IconCoordinate getIcon(Entity entity, ItemStack itemStack){
+        int meta = itemStack.getMetadata();
+        return doorIcons[meta & DyeColor.MASK_COLOR];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelDye.java b/src/main/java/net/minecraft/client/render/item/model/DyeItemModel.java
similarity index 50%
rename from src/main/java/net/minecraft/client/render/item/model/ItemModelDye.java
rename to src/main/java/net/minecraft/client/render/item/model/DyeItemModel.java
index c11055ee5..fde28dfa1 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelDye.java
+++ b/src/main/java/net/minecraft/client/render/item/model/DyeItemModel.java
@@ -1,28 +1,27 @@
 package net.minecraft.client.render.item.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemDye;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.DyeColor;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemModelDye extends ItemModelStandard{
-    public static IconCoordinate[] dyeIcons = new IconCoordinate[16];
+public class DyeItemModel extends StandardItemModel {
+    public static IconCoordinate[] dyeIcons = new IconCoordinate[DyeColor.COLOR_AMOUNT];
     static {
-        for (int i = 0; i < 16; i++) {
-            dyeIcons[i] = TextureRegistry.getTexture("minecraft:item/dye_" + ItemDye.dyeColors[i]);
+        for (DyeColor c : DyeColor.itemOrderedColors()){
+            dyeIcons[c.itemMeta] = TextureRegistry.getTexture("minecraft:item/dye_" + c.colorID);
         }
     }
-    public ItemModelDye(Item item) {
+    public DyeItemModel(Item item) {
         super(item, null);
     }
 
     public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack){
         int meta = itemStack.getMetadata();
-        return dyeIcons[MathHelper.clamp(meta, 0, 15)];
+        return dyeIcons[meta & DyeColor.MASK_COLOR];
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelFishingRod.java b/src/main/java/net/minecraft/client/render/item/model/FishingRodItemModel.java
similarity index 60%
rename from src/main/java/net/minecraft/client/render/item/model/ItemModelFishingRod.java
rename to src/main/java/net/minecraft/client/render/item/model/FishingRodItemModel.java
index 8a779de23..28da971ef 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelFishingRod.java
+++ b/src/main/java/net/minecraft/client/render/item/model/FishingRodItemModel.java
@@ -1,25 +1,25 @@
 package net.minecraft.client.render.item.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemModelFishingRod extends ItemModelStandard {
+public class FishingRodItemModel extends StandardItemModel {
     protected IconCoordinate rodCast = TextureRegistry.getTexture("minecraft:item/tool_fishingrod_cast");
-    public ItemModelFishingRod(Item item, String namespace) {
+    public FishingRodItemModel(Item item, String namespace) {
         super(item, namespace);
     }
 
     @Override
     public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack){
-        if (entity instanceof EntityPlayer){
+        if (entity instanceof Player){
             // Use the cast fishing rod texture when holding a cast rod
-            if(itemStack == ((EntityPlayer) entity).getHeldItem() && ((EntityPlayer) entity).bobberEntity != null)
+            if(itemStack == ((Player) entity).getHeldItem() && ((Player) entity).bobberEntity != null)
             {
                 return rodCast;
             }
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModel.java b/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
index 650fbe71f..65013fe00 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
@@ -4,11 +4,11 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.ItemRenderer;
 import net.minecraft.client.render.RenderEngine;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import org.jetbrains.annotations.Nullable;
@@ -20,8 +20,8 @@ public abstract class ItemModel {
     public ItemModel(Item item){
         this.item = item;
     }
-    public abstract void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, EntityPlayer player, ItemStack stack, float partialTick);
-    public void renderItem(Tessellator tessellator, ItemRenderer renderer, EntityLiving entityLiving, ItemStack itemStack){
+    public abstract void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, Player player, ItemStack stack, float partialTick);
+    public void renderItem(Tessellator tessellator, ItemRenderer renderer, Mob entityLiving, ItemStack itemStack){
         final Minecraft mc = Minecraft.getMinecraft(this);
         float brightness = entityLiving.getBrightness(1.0f);
         renderItem(tessellator, renderer, itemStack, entityLiving, brightness, true);
